﻿Barrel = LibStub("AceAddon-3.0"):NewAddon("Barrel", "AceConsole-3.0", "AceEvent-3.0")
local ldb = LibStub("LibDataBroker-1.1")
local db_icon = LibStub("LibDBIcon-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Barrel")
local options = {}

function Barrel:OnInitialize()
	self:Config()
	options = LibStub("AceConfigRegistry-3.0"):GetOptionsTable("Barrel", "dialog", "Barrel-0.1")
	self:RegisterChatCommand("br", "ChatCommand")
	self:RegisterChatCommand("Barrel", "ChatCommand")
end

function Barrel:OnEnable()
	self:RegisterObjects()
	ldb.RegisterCallback(self, "LibDataBroker_DataObjectCreated", "DataObjectCreated")
end

function Barrel:DataObjectCreated(event, name, dataobj)
	local Frame = "Barrel"..name
	if not dataobj.icon then
		dataobj.icon = ""
	end
	if (not self.db.profile[Frame]) then
		self.db.profile[Frame] = {}
	end
	db_icon:Register("Barrel"..name, dataobj, self.db.profile[Frame])
	self:CreateMenu(name)
end

function Barrel:RegisterObjects()
	for name, dataobj in ldb:DataObjectIterator() do
		self:DataObjectCreated(nil, name, dataobj)
	end
end

function Barrel:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("Barrel")
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(Barrel, "br", "Barrel", input)
	end
end

-- Copyright 2008, 2009 Copystring"
